<?php

/* **********************************************************************************

  browser4exif2csv 1.01a vom 03.09.2003
  Autor/Kontakt: Jrgen Galupki
  Lizenz:  http://galupki.de/kontakt/readme-kontakt-lizenz.html
  Kontakt: http://galupki.de/kontakt/
  WWW:     http://galupki.de

  siehe/look at     liste_exif.php!


  Was tut das Programm:

  - browsen in einem Verzeichnisbaum der jpg-Bilder mit (+ohne) EXIF (2.2) - Daten enthlt,
    dabei Anzeige (ggf. erzeugen) von Vorschaubildern und EXIF-Daten - Gimmick: Schrfentiefeanzeige
  - extrahieren von EXIF-Daten in CSV-Dateien (insbesondere Canon Powershot A60/A70) (*)
  - extrahierte EXIF-Daten werden durch Kategorien und Stichworte ergnzt (sofern gewnscht/erfasst)
  - "Datenbankabfrage" auf Basis der erzeugten CSV-Dateien als "Prototyp"
  - stellt Dateninput fr eine echte Datenbank/Excel/(...) in Form einer CSV-Datei zur Verfgung

  (*) CSV: comma separated values (trennzeichenoriente Textdatei, Trennzeichen: ";" Semikolon)


  Gedacht ist das ganze als "Ersatzlsung" fr eine kommerzielle (...) (Bild-)Datenbank fr Amateure,
  die zufllig auch (ein wenig reicht schon) Ahnung von php haben. Laufen soll das ganze auf dem
  (heimischen) Rechner in einer WAMP/LAMP (MySQL wird NICHT bentigt) - Umgebung - vor einem
  Einsatz auf einem Internet-WWW-Server sollten diverse Sicherheitslcken geschlossen werden - und
  was zuguterletzt dagegenspricht:

  Die Routinen sind NICHT auf einen Multiuser-/Netzwerkbetrieb ausgelegt! Im Prinzip spricht aber
  nichts dagegen, die Anwendung in einen nicht ffentlich erreichbaren Teil des Webservers zu
  legen...

  Fehlerhinweise und Anregungen nehme ich gerne entgegen (obwohl ich nicht vorhabe die Scripte
  grossartig weiter auszubauen).


  Voraussetzungen:

  Achtung: php compiliert mit EXIF-Untersttzung, mglichst ab 4.3.0, min. 4.2.0
  extension=php_exif.dll muss in php.ini eingebunden sein!
  extension=php_gd2.dll muss in php.ini eingebunden sein!
  php-Version 4.3.3 empfohlen!


  Mitgelieferte Dateien:

  readme.txt
  liste_exif.php         Verzeichnisorientiertes Browsen, Aufbau Vorschauverzeichnis + CSV-Dateien
  exif.php               Routinen zum extrahieren der EXIF-Daten
  canon.php              Routinen zum extrahieren der EXIF- CANON-Makernotes (Exif 2.2, soweit ich es herausbekommen habe)
  notes.php              Routinen zum Vorschauverzeichnis (lesen/schreiben Dateien)
  liste_exif_search.php  Prototyp einer "Datenbankabfrage" auf Basis der erzeugten CSV-Dateien
  style.css              CSS


  Achtung: Es sind Variablen im php-Source vorzubelegen, und zwar:

  Pflicht:
           $bilder_verzeichnis    in liste_exif.php   Wurzelverzeichnis aller Bilder
           $vorschau_verzeichnis  in notes.php        Verzeichnis fr ALLE Vorschaubilder und CSV-Dateien
                                                      Dieses EINE Verzeichnis MUSS BESCHREIBBAR SEIN (Rechte UNIX!)

  nice to have:
           $kbfaktor35mm          in exif.php         Brennweite die 35mm Kleinbild entsprche (auch wenn Kamera das phys. nicht liefern knnte)
           $CCDWidth              in exif.php         Breite des CCDs in mm (Computed-Wert nicht genau genug)
           $vbg                   in exif.php         Pixelbreite fr zu generierende Vorschaubilder
           $taglist               in notes.php        Anzuzeigende / nach CSV zu extrahierende Bildwerte (siehe unten)

  Achtung:
  Die Programme sind nicht fail-save, d.h. es fehlen Abfragen die zu einer sicheren(!) Ausfhrung
  bei einem Provider bzw. berhaupt zum fehlertoleranten arbeiten ntig wren - insbesondere bei
  einem "register_globals=ON"! AUsserdem nicht mehrfachbenutzer/Netzwerkfhig!

  Ein Bilder-Unterverzeichnis sollte nicht allzuviele Dateien ohne Exif-Daten beiinhalten,
  da ansonsten beim zeitaufwendigen extrahieren/erzeugen der Vorschaubilder der
  php-timeout mglicherweise zuschlgt. Die Routinen zur Erzeugung von Vorschaubildern
  im Falle eines Bildes OHNE vorbereitetes Vorschaubild sind sehr resourcenhungrig,
  da freut sich wahrscheinlich jeder Provider - also eher etwas fr eine Entwicklungs-
  umgebung. Abhilfe Abbruch: php-timeout erhhen oder bei Anzeige der timeout-Fehlermeldung
  einfach einen Seitenreload so oft durchfhren, bis alle Vorschaubilder angelegt sind.
  Sobald alle Vorschaubilder extrahiert vorhanden sind, geht die Anzeige eigentlich
  recht fix.

  Ebenfalls hchst ungnstig ist das abbrechen eines Scripts vor dem normalen beenden
  durch den Browser (innerhalb liste_exif.php). In diesem Falle wird die CSV-Datei
  unvollstndig sein! Repariert sich aber, wenn man dieses Verzeichnis nochmal
  besucht (oder reload).


  Zuguterletzt: In der ausgelieferten Version ist $taglist so gesetzt, wie ICH es nutze.
  In die CSV-Datei wird ZUSTZLICH und in jedem Fall geschrieben:
     Bilddatei;Vorschaubild;FileName;year;month;day;hh;mm;kategorie;stichwort;...$taglist[...]...

  $taglist kann beliebig angepasst/eingestellt werden. Es werden ungefhr folgende DatenFelder ermittelt:

AFPointSelected
AFPointUsed
BytesImageInfo                               Canon Makernotes  Anzahl Werte
BytesModeArray                               Canon Makernotes  Anzahl Werte
CCDWidth                                     Von php berechneter Wert - Qualitt mig
Contrast                                     Canon: PhotoEffect...
DateTimeOriginal                             Aufnahmezeitpunkt
DigitalZoom
DigitalZoomRatio
DigitalZoomRatio_                            Als Faktor
DigitalZoomRatio_N
DigitalZoomRatio_Z
DriveMode
EasyShooting
ExifImageLength
ExifImageWidth
ExifVersion
ExposureBiasValue                            Belichtungskorrektur
ExposureMode
ExposureMode_Canon
ExposureTime                                 Belichtungszeit
FNumber                                      Blende
FileDateTime                                 Dateidatum/zeit
FileDateTimeCondensed_                       jjjjmmtt-hhmmss
FileName
FileSize                                     ... KB
FirmwareVersion
Flash
FlashActivity
FlashBias
FlashDetails
Flash_Canon
FocalLength                                  Brennweite
FocalUnits
FocusMode
FocusMode_
FocusType
Height_
ISO                                          Leider nicht im Auto-Mode
ImageDescription
ImageRatio_                                  Verhltnis Breite:Hhe
ImageSize
KBFocalLength_                               Brennweite umgerechnet auf Kleinbildformat
LongFocalLength
Macro
Make
MeteringMode
MeteringMode_Canon
Model
OpticalZoomRatio_                            Als Faktor
OwnerName
PhotoEffect                                  Canon: Farbsttigung, Schrfung, s/w, sepia usw.
Quality
Saturation
SelfTimer
SequenceNumber
Sharpness
ShortFocalLength
SubjectDistance                              Canon A60/A70: in Metern
WhiteBalance
WhiteBalance_Canon
Width_
ZoomRatio_                                   Insgesamt, also Optischer Zoom * Digitalzoom
dof_CCDWidth                                 depth of field: CCD-Breite in mm
dof_ZkD                                      depth of field: Zerstreuungskreisdurchmesser in mm
dof_Fp                                       depth of field: Scharf bis FERNpunkt Entfernung in m
dof_Hf                                       depth of field: Hyperfokale Distanz
dof_HfNp                                     depth of field: Hyperfokale Nahdistanz
dof_Np                                       depth of field: Scharf ab NAHpunkt Entfernung in m
dof_info
day
month
year
hh
mm

********************************************************************************** */

include("exif.php");
include("canon.php");
include("notes.php");



if (isset($_REQUEST['reset'])) {
// unset() aller Variablen (reset-Knopf gedrckt!) - bisschen gefhrlich...

      unset($_REQUEST['doit']);
}



// Verzeichnisse und Dateien
// im Vorschau-Verzeichnis werden die Vorschaubilder soweit vorhanden
// abgelegt - schreibender Zugriff ist erforderlich!

$endungen=".jpg";


if ( $_REQUEST['bilder_verzeichnis'] == "" )  {

// $bilder_verzeichnis = "C:/Privat/HPC/Backup/F/Bild/Digifotos/";
   $bilder_verzeichnis = "C:/";

}  else {
   $bilder_verzeichnis = $_REQUEST['bilder_verzeichnis'];
}

if ( !isset($_REQUEST['child']) ) {
   $wurzeldir = $bilder_verzeichnis;
}  else {
   $wurzeldir = $_REQUEST['wurzeldir'];
}


// der folgende Abschnitt erzeugt zwei Arrays
// $verz enthlt alle (Unter-)Verzeichnisse und das bergeordnete Verzeichnis
//       - dieses aber nur bis die "Wurzel" erreicht wird
// $bilder enthlt alle passenden (Endungen...) Dateien des akt. Verzeichnisses
unset($verz);
unset($bilder);
$handle = opendir($bilder_verzeichnis);
while ($file = @readdir($handle)) {
   if ( is_dir($bilder_verzeichnis.$file) AND $file!= "." ) {
      if ( $file == ".." ) {
         $tmp = $bilder_verzeichnis . $file;
         $tmp = substr($tmp, 0, -3);
         $tmp = substr($tmp, 0, strrpos($tmp, "/")) . "/";
//         echo "<br>$tmp<br>";
         if ( strlen($tmp) >= strlen($wurzeldir) ) {
            $verz[] = $tmp;
         }
      }  else {
         $verz[] = $bilder_verzeichnis . $file . "/";
      }
   }  else {
      if ( strpos($endungen, substr(strtolower($file),-3))) {
         $bilder[] = $bilder_verzeichnis . $file;
      }
   }
}
closedir($handle);
@asort($verz);
@asort($bilder);


// PHP-Version ermitteln

$verstr=explode(".",phpversion());
$vernum=$verstr[0]*100+$verstr[1]*10+$verstr[2]*1;


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>

<head>
 <meta name="Author" content="juergen galupki http://galupki.de">
 <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
 <link rel="stylesheet" href="style.css" type="text/css">
 <meta name="robots" content="noindex,nofollow,noarchive">
 <title>Bildkatalog <?php echo $bilder_verzeichnis . " php-Ver " . phpversion(); ?></title>
</head>


<body>
<?php echo $vinfo; ?>
<p>


<a href="liste_exif_search.php">zur GESAMTLISTE</a>

<p>

<?php
// Liste aller Verzeichnisse sortiert
foreach ($verz as $verzeichnis) {
?>
      <a href="<?php echo $_SERVER['PHP_SELF']; ?>?child=x&amp;wurzeldir=<?php echo $wurzeldir; ?>&amp;bilder_verzeichnis=<?php echo $verzeichnis; ?>">
         <span class="dirs"> <?php echo $verzeichnis; ?></span></a> <br>
<?php
}

if ( count($bilder)==0 ) {
   die("<p>Es befinden sich keine Bilder \"$endungen\" im Verzeichnis.");
}


// zentrale Verzeichnisdatei fortschreiben / pruefen

$actual_nr = csv_dirfile($bilder_verzeichnis);       // welche Datei
read_csv_comment($actual_nr);                               // alte Kategorien/Stichwrter lesen

$notes_finished=false;
write_csv_entry($actual_nr, "", "", "", "", true);   // Datei neu anlegen

// Liste aller Bilder

$bildnr = 0;

?>

<p>
<form action="<?php echo $_SERVER['PHP_SELF']; ?>?child=x&amp;wurzeldir=<?php echo $wurzeldir; ?>&amp;bilder_verzeichnis=<?php echo $bilder_verzeichnis; ?>" method="post">

<table border="1" width="100%">
<tr>
<th>Datei- und Kameraangaben<p>
    &nbsp;<input type="submit" name="doit"  value="Kategorien+Stichworte sichern">&nbsp;
    <br>&nbsp;
<!--     &nbsp; <input type="submit" name="reset" value="Reset"> -->
</th>
<th>Bild-<br>Gre,<br>Qualitt</th><th>Vorschaubild</th><th>Details</th>
</tr>

<?php



foreach ($bilder as $bild) {

   $bildnr++;

// Grundinformationen besorgen

   exif_data();


// Vorschaubild - ggf. anlegen - und wichtigste Daten

   $vorschau_name = $vorschau_verzeichnis
                  . str_replace(".jpg","-".$result['FileDateTimeCondensed_']."-v.jpg", strtolower($result['FileName']));

   if ( $sw_exif==true ) {
      exif_extrakt_vorschaubild($bild, $vorschau_name);
   }  else {
      create_vorschaubild($bild, $vorschau_name);
   }


   $parameter=@getimagesize($vorschau_name);

// kategorien und stichwoerter im vorschaubild hinterlegen waere auch ne idee:
// $parameter=@getimagesize($vorschau_name, &$info);
//   if (isset ($info["APP13"])) {
//      $iptc = iptcparse ($info["APP13"]);
//      var_dump ($iptc);
//array(3) { ["2#000"]=> array(1) { [0]=> string(2) "" } ["2#020"]=> array(2) { [0]=> string(13) "testkategorie" [1]=> string(10) "kategorie2" } ["2#025"]=> array(2) { [0]=> string(14) "teststichwort1" [1]=> string(10) "stichwort2" } }
//array iptcembed ( string iptcdata, string jpeg_file_name [, int spool]) // wieder zurueckschreiben
//   }

   $width_height=$parameter[3];


// Verzeichnisdatei mit Bild fortschreiben

   if (isset($_REQUEST["k".$bildnr])) {
      $comment[basename($bild)]["K"] = $_REQUEST["k".$bildnr];
   }
   if (isset($_REQUEST["s".$bildnr])) {
      $comment[basename($bild)]["S"] = $_REQUEST["s".$bildnr];
   }  elseif ($result['ImageDescription']!="") {
      $comment[basename($bild)]["S"] = $result['ImageDescription'];
   }

write_csv_entry($actual_nr, $bild, $vorschau_name, $comment[basename($bild)]["K"], $comment[basename($bild)]["S"], false);


// Daten ausgeben


   echo "<tr>\n";

   echo "<td width=\"20%\">\n<strong>$bild</strong><p>" . $result['ImageDescription'] . "<p>\n";

   if ( $result['Model']!="")            echo $result['Model'];
   if ( $result['Make']!="" )            echo " (" . $result['Make'] . ")<br>\n";
   if ( $result['FirmwareVersion']!="" ) echo $result['FirmwareVersion'] . "<p>\n";
   if ( $result['OwnerName']!="" )       echo $result['OwnerName'] . "<p>\n";

   echo "<p>" . $result['DateTimeOriginal'] . "<br>" . $result['FileDateTime'];
   echo "<p>\n";

// Kategorie und Stichwort

   echo "<b>Kategorien</b><br><input name=\"k$bildnr\" type=\"text\" size=\"50\" maxlength=\"110\" value=\"";
   if (isset($_REQUEST["k".$bildnr])) {
      echo $_REQUEST["k".$bildnr];
   }  else {
      echo $comment[basename($bild)]["K"];
   }
   echo "\"><br>\n";

   echo "<b>Stichworte</b><br><input name=\"s$bildnr\" type=\"text\" size=\"50\" maxlength=\"110\" value=\"";
   if (isset($_REQUEST["s".$bildnr])) {
      echo $_REQUEST["s".$bildnr];
   }  else {
      echo $comment[basename($bild)]["S"];
   }
   echo "\">\n";

   echo "</td>\n";

   echo "<td width=\"10%\">" . $result['FileSize'] . "<br>&nbsp;<br>" . $result['Width_'] . " x " . $result['Height_']
        . "<br>Ratio " . $result['ImageRatio_'] . "<p>"
        . $result['ImageSize'] . "<br>" . $result['Quality'];
   echo "</td>\n";

   echo "<td width=\"160\">"
        . "<a href=\"file:///$bild\" target=\"vollbild\">"
        . "<img src=\"file:///$vorschau_name\" $width_height title=\"Bild anzeigen\" alt=\"Vorschaubild\" border=\"0\">"
        . "</a>\n";
   echo "</td>\n";
   echo "<td>";

// EXIF- und Makernotes Einzeldaten ausgeben

   echo "<table width=\"100%\" border=\"0\">\n";

     foreach ($taglist as $tag) {
        if ($result[$tag]!="" AND $result[$tag]!="0") {
           echo "<tr>\n";
           echo "<td width=\"40%\">$tag</td>\n";
           echo "<td>".$result[$tag]."</td>\n";
           echo "</tr>\n";
        }
     }

// testdaten
//  echo "<tr><td colspan=\"2\">\n";
//  show_results(true, false, false);
//  echo "</td></tr>\n";

   echo "</table>\n";

// Ende EXIF- und Makernotes

   echo "</td>\n";
   echo "</tr>\n";
}

?>

</table>

<?php
echo $bildnr . " Bilder gefunden.<br>";

$notes_finished = true;
copy_csv_file($actual_nr);
?>

</form>


</body>

</html>